import functools
import typing

def store_namespace(local_namespace):
    def adding_namespace_decorator(function):
        @functools.wraps(function)
        def wrapper(*args, **kwargs):
            return function(*args, **kwargs)
        function.__locals__ = local_namespace            
        return wrapper
    return adding_namespace_decorator
    
    
def unwrap_function(function):
    if '__wrapped__' in function.__dict__:
        return unwrap_function(function.__wrapped__)
    return function
    
    
def get_type_hints(function, localns = None, globalns = None):
    function = unwrap_function(function) # apply workaround for issue: https://bugs.python.org/issue37838
    
    # now search for __locals__ attribute in function object
    if localns is None and '__locals__' in function.__dict__:
        localns = function.__locals__
    
    return typing.get_type_hints(function, localns = localns, globalns = globalns)